F12<-function(data, var, labels, percut=NULL, per=FALSE, explode=0.05,
ResetPAR=TRUE, PAR=NULL,  PIE3D=NULL,
COLOR=NULL, MTEXT= NULL, TEXT=NULL){



###############################################
#Seccion que realiza el procedimiento
###############################################

datos<-data

datosT<-data.frame(subset(datos, select=var), subset(datos, select=labels))

datos<-na.exclude(datosT)


###############################################
#Seccion que muestra los resultados
###############################################


suma<-sum(datos[,var])
var1<-datos[,var]*100/suma

datos<-cbind(datos,var1)

if(!is.null(percut)){
datos<-subset(datos,(var1 > percut))
}


if(ResetPAR==TRUE){
#Resetear par() a las opciones por defecto
resetPar <- function() {
    dev.new()
    op <- par(no.readonly = TRUE)
    dev.off()
    op
}
par(resetPar()) }
else{
}

if(!is.null(PAR)){
parexe<-paste("par(new,",toString(x=PAR), ")")
eval(parse(text=parexe))
}
else{
par(font.lab=2, mar=c(5,5,3,2),cex.lab=1.3)
}

if(!is.null(COLOR)){
color<-COLOR
}
else{
color<-NULL
}

if(per==TRUE) etiq<-paste(datos[,labels]," - ", format(datos[,3], digits=2), "%", sep="") else etiq<-paste(datos[,labels])


if(!is.null(PIE3D)){
pieexe<-paste("plotrix::pie3D(","x=datos[,var],","labels=etiq,", toString(x=PIE3D), ")")
eval(parse(text=pieexe))
}
else{
pieexe<-paste("plotrix::pie3D(","x=datos[,var],","labels=etiq,", "col=color,",
"explode=explode,", "radius=0.87,", "theta=0.7,", "height=0.07,", "labelcex=1.2",")")
eval(parse(text=pieexe))
}




if(!is.null(MTEXT)){
mtextexe<-paste("mtext(",toString(x=MTEXT), ")")
eval(parse(text=mtextexe))
}
else{
}

if(!is.null(TEXT)){
textexe<-paste("text(",toString(x=TEXT), ")")
eval(parse(text=textexe))
}
else{
}







}
