F49<-function(data, varY, varX, method="mean", dev=NULL, BARPLOT=NULL, ResetPAR=TRUE,  PAR=NULL,
order=NULL, OrderCat=NULL, LabelCat=NULL,
 XLAB=NULL, YLAB=NULL, XLIM=NULL, YLIM=NULL, COLOR="green", 
LEGEND=NULL, AXIS=NULL, MTEXT= NULL, TEXT=NULL){


if (missing(OrderCat)) OrderCat=NULL else OrderCat=OrderCat
if (missing(LabelCat)) LabelCat=OrderCat else LabelCat=LabelCat

datos<-data

datos<-data.frame(subset(datos, select=varX), subset(datos, select=varY))

dati<-as.character(unique(datos[,1]))

count<-function(x){ 
length(na.omit(x))
} 


if(ResetPAR==TRUE){
#Resetear par() a las opciones por defecto
resetPar <- function() {
    dev.new()
    op <- par(no.readonly = TRUE)
    dev.off()
    op
}
par(resetPar()) }
else{
}


if(!is.null(YLAB)){
ylab<-YLAB
}
else{
ylab<-varY

}

if(!is.null(XLAB)){
xlab<-XLAB
}
else{
xlab<-varX

}






if(!is.null(PAR)){
parexe<-paste("par(new,",toString(x=PAR), ")")
eval(parse(text=parexe))
}
else{
par(font.lab=2, mar=c(5,5,3,2),cex.lab=1.5)
}



datos[,varX]<-factor(datos[,varX], levels = unique(datos[,varX]), labels = unique(datos[,varX]))

if(!is.null(method)){
dat<-as.matrix(tapply(datos[,varY], datos[,varX],method, na.rm=TRUE))
}
else{
dat<-as.matrix(tapply(datos[,varY], datos[,varX],mean, na.rm=TRUE, na.action="na.pass"))
}



if(!is.null(OrderCat)){
datos[,varX]<-factor(datos[,varX], levels = OrderCat, labels = LabelCat)
}
else{
if(!is.null(order)){
if(order=="decreasing") names<-names(sort(dat[,1], decreasing=TRUE)) else names<-names(sort(dat[,1], decreasing=FALSE))

if(order=="alphaAZ") names<-sort(names, decreasing=FALSE) else names<-names

if(order=="alphaZA") names<-sort(names, decreasing=TRUE) else names<-names


if(!is.null(LabelCat))  LabelCat<-LabelCat else LabelCat<-names
datos[,varX]<-factor(datos[,varX], levels = names, labels = LabelCat)
}
else{
if(!is.null(LabelCat)) datos[,varX]<-factor(datos[,varX], levels = unique(datos[,varX]), labels = LabelCat) else datos<-datos
}
}



if(!is.null(dev)) {
length<- aggregate(datos[, varY],list(datos[, varX]), FUN=count)
sd.t<- aggregate(datos[, varY],list(datos[, varX]), sd, na.rm=TRUE)
if(dev=="sd"){
}
else{
sd.t<-data.frame(sd.t[,1],sd.t[,2]/sqrt(length[,2]))
}
sd.t<-t(sd.t)
sd.t<-sd.t[2,]
}

if(!is.null(dev)){
sd.t<-sd.t[!is.na(sd.t)]
}

if(!is.null(method)){
dat<-as.matrix(tapply(datos[,varY], datos[,varX],method, na.rm=TRUE))
}
else{
dat<-as.matrix(tapply(datos[,varY], datos[,varX],mean, na.rm=TRUE, na.action="na.pass"))
}


dat<-t(dat)






if(!is.null(YLIM)){
minsy<-YLIM[1]
maxsy<-YLIM[2]
}
else{
minsy<-0
if(!is.null(dev)) maxsy<-max(dat[1,],na.rm=TRUE)*1.2+max(as.numeric(sd.t),na.rm=TRUE) else maxsy<-max(dat[1,],na.rm=TRUE)*1.2
}


if(!is.null(COLOR)){
color1<-COLOR
}
else{
color1<-"green"
}


dat<-dat[1,]


dat<-dat[!is.na(dat)]

colnames<-names(dat)



if(!is.null(XLIM)){
minsx<-XLIM[1]
maxsx<-XLIM[2]
}
else{
minsx<-0
maxsx<-length(dat)+1
}

if(!is.null(BARPLOT)){
scatterplotexe<-paste("plotrix::barp(","height=dat,", "ylim=c(minsy,maxsy),", "xlim=c(minsx,maxsx),",  toString(x=BARPLOT), ")")
bar<-eval(parse(text=scatterplotexe))
}
else{
scatterplotexe<-paste("plotrix::barp(","height=dat,", "ylim=c(minsy,maxsy),",
"xlim=c(minsx,maxsx),","col=color1,", "xlab=xlab,", "ylab=ylab,", "names.arg=colnames,",  "shadow=TRUE,",
"cylindrical=TRUE", ")")
bar<-eval(parse(text=scatterplotexe))
}




lon<-length(dati)

longitud<-((bar$x[2]-bar$x[1])/lon)



if(!is.null(dev)) {
for(zz in 1:lon){
arrows(bar$x[zz], dat[zz]+as.numeric(sd.t[zz]),  bar$x[zz], dat[zz],  angle=90, code=1, length=longitud)
}
}



if(!is.null(TEXT)){
textexe<-paste("text(",toString(x=TEXT), ")")
eval(parse(text=textexe))
}
else{
}


if(!is.null(LEGEND)){
legendexe<-paste("legend(",toString(x=LEGEND), ")")
eval(parse(text=legendexe))
}
else{
}




if(!is.null(MTEXT)){
mtextexe<-paste("mtext(",toString(x=MTEXT), ")")
eval(parse(text=mtextexe))
}
else{
}




if(!is.null(AXIS)){
axisexe<-paste("axis(",toString(x=AXIS), ")")
eval(parse(text=axisexe))
}
else{
}





}
