F58<-function(data, varY, varX, zones=NULL, zoneNames=NULL, 
STRATIPLOT=NULL,  XLAB=NULL, YLAB=NULL,  YLIM=NULL,
type = c("poly","g"), pch=16, cex=1, col.line="black", col.symbol="black",
col.refline="black", col.smooth="blue", col.poly="red",
col.zones="transparent", lty=1, lwd.h=1, lty.smooth=1, lwd.smooth=2,
lty.zones=1, lwd.zones=1){

require(analogue)

datos<-data

datos<-data.frame(subset(datos, select=varY), subset(datos, select=varX))



if(!is.null(YLAB)){
ylab<-YLAB
}
else{
ylab<-varY
}

if(!is.null(XLAB)){
xlab<-XLAB
}
else{
xlab<-NULL
}

if(!is.null(YLIM)){
minsy<-YLIM[1]
maxsy<-YLIM[2]
}
else{
minsy<-min(datos[,varY], na.rm=TRUE)
maxsy<-max(datos[,varY], na.rm=TRUE)
}


if(!is.null(STRATIPLOT)){
if(!is.null(zones)){
tx<-paste("analogue::Stratiplot(","x=datos[,varX],", "y=datos[,varY],", "zones=zones,", "zoneNames=zoneNames,", toString(x=STRATIPLOT), ")")
eval(parse(text=tx))
}
else{
tx<-paste("analogue::Stratiplot(","x=datos[,varX],", "y=datos[,varY],", toString(x=STRATIPLOT), ")")
eval(parse(text=tx))
}
}
else{
if(!is.null(zones)){
tx<-paste("analogue::Stratiplot(","x=datos[,varX],", "y=datos[,varY],", "xlab=xlab,", "ylab=ylab,", "zones=zones,", "zoneNames=zoneNames,",
"ylim=c(minsy,maxsy),",  "type=type,", "pch=pch,", "cex=cex,", "col.line=col.line,", "col.symbol=col.symbol,",
"col.refline=col.refline,", "col.smooth=col.smooth,", "col.poly=col.poly,", "col.zones=col.zones,", "lty=lty,", "lwd.h=lwd.h,",
"lty.smooth=lty.smooth,", " lwd.smooth=lwd.smooth,", "lty.zones=lty.zones,", "lwd.zones=lwd.zones",")")
eval(parse(text=tx))
}
else{
tx<-paste("analogue::Stratiplot(","x=datos[,varX],", "y=datos[,varY],", "xlab=xlab,", "ylab=ylab,", 
"ylim=c(minsy,maxsy),",  "type=type,", "pch=pch,", "cex=cex,", "col.line=col.line,", "col.symbol=col.symbol,",
"col.refline=col.refline,", "col.smooth=col.smooth,", "col.poly=col.poly,", "col.zones=col.zones,", "lty=lty,", "lwd.h=lwd.h,",
"lty.smooth=lty.smooth,", " lwd.smooth=lwd.smooth,", "lty.zones=lty.zones,", "lwd.zones=lwd.zones",")")

eval(parse(text=tx))
}
}


}
