F65<-function(data, winds, windd, var=NULL, date=NULL, year, month,
date.format="%d/%m/%Y %H:%M", type="default", ws.int=2, statistic="prop.count", 
key.position="right", paddle=TRUE, annotate=TRUE, WROSE=NULL, PROSE=NULL, COLOR="default",
SUB=NULL,  dec=","){


###############################################
#Seccion que realiza el procedimiento
###############################################


datos<-data

if(is.null(date)){
c<-lapply(datos,class)
if(any(c=="factor")==TRUE){
cc<-which(c=="factor")
datos<-datos[,-cc]
}
if(any(c=="character")==TRUE){
cc<-which(c=="character")
datos<-datos[,-cc]
}
}



##  various check to make sure all the data are available ##

if(missing(date) & type!="default") {
stop("Error: It is necessary to specify the variable date")
}

if(missing(date) & !missing(year)) {
stop("Error: It is necessary to specify the variable date")
}

if(missing(date) & !missing(month)) {
stop("Error: It is necessary to specify the variable date")
}

#End check

cn<-colnames(datos)

if(!is.null(winds)){
pos<-which(cn==winds)
colnames(datos)[pos]<-"ws"
}

if(!is.null(windd)){
pos<-which(cn==windd)
colnames(datos)[pos]<-"wd"
}


if(!is.null(date)){

cn<-colnames(datos)
pos<-which(cn==date)
colnames(datos)[pos]<-"date"


if(class(datos$date)=="factor" | class(datos$date)=="character"){
datos$date<-as.POSIXct(strptime(datos$date, format = date.format))
}



if(class(datos$date)=="Date" | class(datos$date)=="POSIXt" | class(datos$date)=="POSIXct"){
if(date.format=="%d/%m/%Y %H:%M"){
datos$date<-paste(x=format(datos$date, "%d"),"/",format(datos$date, "%m"),"/",
format(datos$date, "%Y"), " " ,format(datos$date, "%H"), ":", format(datos$date, "%M"), sep="")
}

if(date.format=="%d/%m/%Y"){
datos$date<-paste(x=format(datos$date, "%d"),"/",format(datos$date, "%m"),"/",
format(datos$date, "%Y"), sep="")
}

if(date.format=="%Y/%m/%d %H:%M"){
datos$date<-paste(x=format(datos$date, "%d"),"/",format(datos$date, "%m"),"/",
format(datos$date, "%Y"), " " ,format(datos$date, "%H"), ":", format(datos$date, "%M"), sep="")
}

if(date.format=="%Y/%m/%d"){
datos$date<-paste(x=format(datos$date, "%d"),"/",format(datos$date, "%m"),"/",
format(datos$date, "%Y"), sep="")
}

}



if(date.format=="%Y/%m/%d %H:%M"){ date.format<-"%d/%m/%Y %H:%M"}

if(date.format=="%Y/%m/%d"){ date.format<-"%d/%m/%Y"}



if(dec=="."){
write.csv(x=datos,file = "Temp.csv", row.names=FALSE, sep=",", na="")
}
else{
write.csv2(x=datos,file = "Temp.csv", row.names=FALSE, sep=";", na="")
}


if(dec=="."){
datos<-openair::import(file="Temp.csv", sep=",", date.format=date.format)
}
else{
datos<-openair::import(file="Temp.csv", sep=";", date.format=date.format)
}

if (missing(year)) {

}
else{
datos<-openair::selectByDate(datos, year = year)
}
if (missing(month)) {
}
else{
datos<-openair::selectByDate(datos, month = month)
}



}#End NULL date



if(!is.null(date)){

cn<-colnames(datos)
pos<-which(cn=="date")

datos2<-datos

datos1<-datos[,-pos]

if(dec=="."){
write.csv(x=datos1,file = "Temp.csv", row.names=FALSE, sep=",", na="")
}
else{
write.csv2(x=datos1,file = "Temp.csv", row.names=FALSE, sep=";", na="")
}


if(dec=="."){
datos1<-read.csv(file="Temp.csv")
}
else{
datos1<-read.csv2(file="Temp.csv")
}

datos<-cbind(datos2[,pos],datos1)
cn<-colnames(datos1)

colnames(datos)<-c("date",cn)

remove(datos1)

remove(datos2)



}#End second NULL date



if(!is.null(var)){
if(!is.null(PROSE)){
if(!is.null(SUB)){
prose<-paste("openair::pollutionRose(","mydata=datos,", "ws='ws',", "wd='wd',", "pollutant=var,", "sub=SUB,", toString(x=PROSE), ")")
eval(parse(text=prose))
}
else{
prose<-paste("openair::pollutionRose(","mydata=datos,", "ws='ws',", "wd='wd',", "pollutant=var,", toString(x=PROSE), ")")
eval(parse(text=prose))
}
}
else{
if(!is.null(SUB)){
prose<-paste("openair::pollutionRose(","mydata=datos,", "ws='ws',", "wd='wd',", "pollutant=var,",
"type=type,","ws.int=ws.int,", "statistic=statistic,", "cols=COLOR,", "paddle=paddle,", "annotate=annotate,", 
"key.position=key.position,", "sub=SUB",  ")")
}
else{
prose<-paste("openair::pollutionRose(","mydata=datos,", "ws='ws',", "wd='wd',", "pollutant=var,",
"type=type,","statistic=statistic,", "cols=COLOR,", "paddle=paddle,", "annotate=annotate,",
"key.position=key.position,", "ws.int=ws.int",  ")")
}
eval(parse(text=prose))
}
}

else{
if(!is.null(WROSE)){
if(!is.null(SUB)){
prose<-paste("openair::windRose(","mydata=datos,", "ws='ws',", "wd='wd',", "pollutant=var,", "sub=SUB,", toString(x=WROSE), ")")
eval(parse(text=prose))
}
else{
prose<-paste("openair::windRose(","mydata=datos,", "ws='ws',", "wd='wd',", "pollutant=var,", toString(x=WROSE), ")")
eval(parse(text=prose))
}
}
else{
if(!is.null(SUB)){
prose<-paste("openair::windRose(","mydata=datos,", "ws='ws',", "wd='wd',", "pollutant=var,",
"type=type,","ws.int=ws.int,", "statistic=statistic,", "cols=COLOR,", "paddle=paddle,", "annotate=annotate,", 
"key.position=key.position,", "sub=SUB",  ")")
}
else{
prose<-paste("openair::windRose(","mydata=datos,", "ws='ws',", "wd='wd',", "pollutant=var,",
"type=type,","statistic=statistic,", "cols=COLOR,", "paddle=paddle,", "annotate=annotate,",
"key.position=key.position,", "ws.int=ws.int",  ")")
}
eval(parse(text=prose))
}
}



}
