F52<-function(data, lbars, rbars, labels,  toplabels=c("Males", "Age","Females"), showvalues=0,
PYRAMIDPLOT=NULL, ResetPAR=TRUE,  PAR=NULL,
XLIM=NULL, COLOR=NULL, LEGEND=NULL, MTEXT= NULL, TEXT=NULL){


datos<-data

datosT<-data.frame(subset(datos, select=labels), subset(datos, select=lbars), subset(datos, select=rbars))


datos<-na.exclude(datosT)


dati<-append(lbars,rbars)

len<-length(dati)


s<-sum(datos[,-1])

for(ss in 1:len){
datos[,ss+1]<-datos[,ss+1]*100/s
}



if(!is.null(COLOR)){
color1<-COLOR
}
else{
color1<-rainbow(length(dati), alpha=0.4)
}


if(!is.null(XLIM)){
XLIM1<-XLIM[1]
XLIM2<-XLIM[2]
}
else{
XLIM1<-ceiling(max(datos[,-1]))
XLIM2<-ceiling(max(datos[,-1]))
}





if(ResetPAR==TRUE){
#Resetear par() a las opciones por defecto
resetPar <- function() {
    dev.new()
    op <- par(no.readonly = TRUE)
    dev.off()
    op
}
par(resetPar()) }
else{
}





if(!is.null(PAR)){
parexe<-paste("par(new,",toString(x=PAR), ")")
eval(parse(text=parexe))
}
else{
par(font.lab=2, mar=c(5,5,3,2),cex.lab=1.5)
}

max<-len/2

print(datos)

for(zz in 1:max){
if(zz>1) add<-TRUE else add<-FALSE
if(zz==showvalues) show=TRUE else show=FALSE

if(!is.null(PYRAMIDPLOT)){
scatterplotexe<-paste("plotrix::pyramid.plot(","lx=datos[,lbars[zz]],", "rx=datos[,rbars[zz]],", "labels=datos[,labels],", toString(x=PYRAMIDPLOT), ")")
eval(parse(text=scatterplotexe))
}
else{
scatterplotexe<-paste("plotrix::pyramid.plot(","lx=datos[,lbars[zz]],", "rx=datos[,rbars[zz]],", "labels=datos[,labels],",
"add=add,","lxcol=color1[zz],", "rxcol=color1[zz+max],","xlim=c(XLIM1,XLIM2),", "show.values=show,",  "top.labels=toplabels",")")
eval(parse(text=scatterplotexe))
}
}





if(!is.null(TEXT)){
textexe<-paste("text(",toString(x=TEXT), ")")
eval(parse(text=textexe))
}
else{
}


if(!is.null(LEGEND)){
legendexe<-paste("legend(",toString(x=LEGEND), ")")
eval(parse(text=legendexe))
}
else{
legendexe<-paste("legend(","x='topleft',","legend=unique(dati),", "bty='n',", "col=color1,",
"pch=15", ")")
eval(parse(text=legendexe))
}




if(!is.null(MTEXT)){
mtextexe<-paste("mtext(",toString(x=MTEXT), ")")
eval(parse(text=mtextexe))
}
else{
}







}
